var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  default: () => swcReact
});
var swc = __toModule(require("@swc/core"));
var import_lodash = __toModule(require("lodash.merge"));

// src/react-refresh-helper.ts
var import_fs = __toModule(require("fs"));
var runtimeFilePath = require.resolve("react-refresh/cjs/react-refresh-runtime.development.js");
var reactRefreshExports = `
(function (){
  window.$react_refresh_exports$ = null
  let exports = {}
  return () => {
    if (window.$react_refresh_exports$) return window.$react_refresh_exports$
    ${import_fs.default.readFileSync(runtimeFilePath, "utf-8").replace("process.env.NODE_ENV", JSON.stringify("development"))}
    exports.performReactRefresh = (function debounce(fn) {
      let handle
      return () => {
        cancelAnimationFrame(handle)
        handle = requestAnimationFrame(fn)
      }
    }(exports.performReactRefresh))
    window.$react_refresh_exports$ = exports
    return exports
  }
}())()
`;
var reactRefreshRuntimeCode = `
if (process.env.NODE_ENV !== 'production' && typeof window !== 'undefined') {
  const runtime = ${reactRefreshExports};
  runtime.injectIntoGlobalHook(window);
  window.$RefreshReg$ = () => {};
  window.$RefreshSig$ = () => type => type;
}
`.replace("process.env.NODE_ENV", JSON.stringify("development"));
var addReactFreshWrapper = (id, code, collector) => {
  let updater;
  if (collector.isAbsolutelyNotReactRefreshBoundary || collector.exportedNames.size === 0) {
    updater = "";
  } else {
    updater = `
    if (${[...collector.exportedNames.values()].map((name) => `RefreshRuntime.isLikelyComponentType(${name})`).join("&&")}) {
      import.meta.hot.accept()
    } else {
      // For now, calling import.meta.hot.invalidate() simply reloads the page. https://vitejs.dev/guide/api-hmr.html#hot-dispose-cb
      // TODO: We should ask user before reloading the page.
      import.meta.hot.invalidate()
    }
`;
  }
  return `
let prevRefreshReg;
let prevRefreshSig;
const RefreshRuntime = window.$react_refresh_exports$;

if (import.meta.hot) {
  prevRefreshReg = window.$RefreshReg$;
  prevRefreshSig = window.$RefreshSig$;
  window.$RefreshReg$ = (type, id) => {
    const fullId = ${JSON.stringify(id)} + ' ' + id;
    RefreshRuntime.register(type, fullId);
  }
  window.$RefreshSig$ = RefreshRuntime.createSignatureFunctionForTransform;
}

${code}

if (import.meta.hot) {
  window.$RefreshReg$ = prevRefreshReg;
  window.$RefreshSig$ = prevRefreshSig;
  ${updater}
  RefreshRuntime.performReactRefresh()
}`;
};

// src/ExportNameCollector.ts
var import_Visitor = __toModule(require("@swc/core/Visitor"));
function isComponentLikeName(name) {
  return typeof name === "string" && name[0] >= "A" && name[0] <= "Z";
}
function neverCheck(foo) {
  throw new Error(`expected never got ${foo}`);
}
var ExportNameCollector = class extends import_Visitor.default {
  constructor() {
    super(...arguments);
    this.exportedNames = /* @__PURE__ */ new Set();
    this.isAbsolutelyNotReactRefreshBoundary = false;
  }
  addName(name) {
    if (isComponentLikeName(name)) {
      this.exportedNames.add(name);
    } else {
      this.isAbsolutelyNotReactRefreshBoundary = true;
    }
  }
  handleExportDefaultExpression(node) {
    const { expression: exp } = node;
    if (exp.type === "Identifier") {
      this.addName(exp.value);
    } else if (exp.type === "CallExpression") {
      const isMemoFn = exp.callee.type === "Identifier" && exp.callee.value === "memo";
      const componentName = exp.arguments[0] && exp.arguments[0].expression.type === "Identifier" ? exp.arguments[0].expression.value : null;
      if (isMemoFn && componentName) {
        this.addName(componentName);
      } else {
        this.isAbsolutelyNotReactRefreshBoundary = true;
      }
    } else {
      this.isAbsolutelyNotReactRefreshBoundary = true;
    }
  }
  handleExportDeclaration(node) {
    const { declaration } = node;
    const { type } = declaration;
    if (type === "TsInterfaceDeclaration" || type === "TsModuleDeclaration" || type === "TsTypeAliasDeclaration") {
    } else if (type === "TsEnumDeclaration" || type === "ClassDeclaration") {
      this.isAbsolutelyNotReactRefreshBoundary = true;
    } else if (type === "FunctionDeclaration") {
      this.addName(declaration.identifier.value);
    } else if (type === "VariableDeclaration") {
      declaration.declarations.flatMap((declarator) => declarator.id.type === "Identifier" ? [declarator.id.value] : []).forEach((name) => this.addName(name));
    } else {
      neverCheck(type);
    }
  }
  handleExportDefaultDeclaration(moduleDecl) {
    const { decl } = moduleDecl;
    if (decl.type === "FunctionExpression") {
      this.addName(decl.identifier.value);
    } else if (decl.type === "ClassExpression") {
      this.isAbsolutelyNotReactRefreshBoundary = true;
    }
  }
  handleExportNamedDeclaration(moduleDecl) {
    var _a, _b;
    for (const s of moduleDecl.specifiers) {
      let exportName;
      if (s.type === "ExportNamespaceSpecifier") {
        this.isAbsolutelyNotReactRefreshBoundary = true;
        break;
      } else if (s.type == "ExportDefaultSpecifier") {
        exportName = s.exported.value;
      } else {
        exportName = (_b = (_a = s.exported) == null ? void 0 : _a.value) != null ? _b : s.orig.value;
        if (exportName === "default") {
          exportName = s.orig.value;
        }
      }
      this.addName(exportName);
    }
  }
  visitModuleDeclaration(moduleDecl) {
    if (this.isAbsolutelyNotReactRefreshBoundary) {
      return moduleDecl;
    }
    if (moduleDecl.type === "ImportDeclaration" || moduleDecl.type === "TsExportAssignment" || moduleDecl.type === "TsImportEqualsDeclaration" || moduleDecl.type === "TsNamespaceExportDeclaration") {
    } else if (moduleDecl.type === "ExportAllDeclaration") {
      this.isAbsolutelyNotReactRefreshBoundary = true;
    } else if (moduleDecl.type === "ExportDefaultExpression") {
      this.handleExportDefaultExpression(moduleDecl);
    } else if (moduleDecl.type === "ExportDeclaration") {
      this.handleExportDeclaration(moduleDecl);
    } else if (moduleDecl.type === "ExportDefaultDeclaration") {
      this.handleExportDefaultDeclaration(moduleDecl);
    } else if (moduleDecl.type === "ExportNamedDeclaration") {
      this.handleExportNamedDeclaration(moduleDecl);
    }
    return moduleDecl;
  }
};

// src/index.ts
function swcReact(options = {}) {
  const {
    reactFresh = true,
    swcOptions = {},
    jsxRuntime = "automatic"
  } = options;
  let isDevelopment = false;
  const ctx = {
    get isEnableReactRefresh() {
      return isDevelopment && reactFresh;
    }
  };
  return [
    {
      name: "vite-plugin-swc-react",
      enforce: "pre",
      config(config, env) {
        isDevelopment = env.mode === "development";
        config.esbuild = false;
      },
      transformIndexHtml() {
        if (ctx.isEnableReactRefresh) {
          return [
            {
              tag: "script",
              attrs: { type: "module" },
              children: reactRefreshRuntimeCode
            }
          ];
        }
      },
      async transform(code, id) {
        if (!id.includes("node_modules") && /\.(js|mjs|jsx|ts|tsx)$/.test(id)) {
          const isTS = /\.(ts|tsx)$/.test(id);
          const is_SX = !id.endsWith(".ts");
          const collector = isDevelopment && is_SX ? new ExportNameCollector() : null;
          const options2 = __spreadProps(__spreadValues({}, collector ? {
            plugin: swc.plugins([(p) => collector.visitProgram(p)])
          } : null), {
            filename: id,
            jsc: {
              target: "es2021",
              parser: {
                syntax: isTS ? "typescript" : "ecmascript",
                [isTS ? "tsx" : "jsx"]: is_SX
              },
              transform: {
                react: {
                  development: isDevelopment,
                  runtime: jsxRuntime,
                  refresh: ctx.isEnableReactRefresh
                }
              }
            }
          });
          const resolveSWCOptions = (0, import_lodash.default)(options2, swcOptions);
          const transformed = await swc.transform(code, resolveSWCOptions);
          return __spreadProps(__spreadValues({}, transformed), {
            code: isDevelopment && reactFresh && collector ? addReactFreshWrapper(id, transformed.code, collector) : transformed.code
          });
        }
      }
    }
  ];
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
